<style>
.timeselect-footer {
  padding: 2px 16px;
  background-color: #0080ff;
  color: white;
  height: 45px;
}

.timeselect-footer button {
  border: none;
  outline: none;
  color: inherit;
  padding: 14px 16px;
  background-color: inherit;
  font-family: inherit;
  font-weight: bold;
  float: right;
}

.timeselect-footer button:hover:not(:disabled),
.timeselect-footer button:focus:not(:disabled) {
  color: #000;
  text-decoration: none;
  cursor: pointer;
}
.timeselect-footer button:disabled {
  color: #777;
  text-decoration: none;
  cursor: not-allowed;
}

.timeselect-entry table {
  padding: 40px 40px 16px 16px;
  border: none;
  width: 100%;
}

.timeselect-entry td:first-child,
.timeselect-entry td:last-child {
  white-space: nowrap;
}

.timeselect-entry td:first-child {
  width: 100px;
}

.timeselect-entry td:first-child label {
  right: 0;
  padding: 16px 16px 0 16px;
  font-weight: bold;
}

.timeselect-entry td:last-child {
  width: 300px;
}

.timeselect-entry td:last-child label {
  padding: 16px 32px 0 32px;
}

.timeselect-entry td:not(:last-child) td:not(:last-child) {
  width: 100%;
}

.timeselect-entry input {
  border: none;
  border-bottom: 2px solid black;
  padding: 12px 20px;
  margin: 8px 0;
  box-sizing: border-box;
  width: 100%;
}

.timeselect-entry input.invalid {
  border-bottom: 2px solid red;
}

.timeselect-entry label.invalid,
.timeselect-entry table.invalid label {
  color: red;
}
</style>

<form class="timeselect-entry">
  <table id="timeselect-entry-table">
    <tr>
      <td><label for="input-start-time">Start</label></td>
      <td><input type="text" id="input-start-time" name="start"></td>
      <td><label id="parsed-start-time"></label></td>
    </tr>
    <tr>
      <td><label for="input-end-time">End</label></td>
      <td><input type="text" id="input-end-time" name="end"></td>
      <td><label id="parsed-end-time"></label></td>
    </tr>
  </table>

  <div class="timeselect-footer">
    <button id="timeselect-apply" title="Set times and replot">Apply</button>
    <button id="timeselect-reset" title="Reset times to their initial values and replot">Reset</button>
    <button id="timeselect-default" title="Reset times to their default values and replot">Default</button>
    <button id="timeselect-unzoom" title="Set times to their values before zooming">Un-zoom</button>
    <button id="timeselect-unpassed" title="Set times to the latest data that hasn't been passed yet">Un-passed</button>
  </div>
</form>

<script>
(function() {
    const startTimeEntry = document.getElementById('input-start-time');
    const startTimeDisplay = document.getElementById('parsed-start-time');
    const endTimeEntry = document.getElementById('input-end-time');
    const endTimeDisplay = document.getElementById('parsed-end-time');
    const displayTable = document.getElementById('timeselect-entry-table');

    let updateResetOnApply = false;

    $('#timeselect-apply').click(function(event) {
        event.preventDefault();
        hideModal();

        let parsedStart = TimeParse.parseTime(startTimeEntry.value, TimeSelect.end_ms, -1);
        const parsedEnd = TimeParse.parseTime(endTimeEntry.value, parsedStart, 1);
        parsedStart = TimeParse.parseTime(startTimeEntry.value, parsedEnd, -1);

        if (!parsedStart || !parsedEnd || parsedStart >= parsedEnd) {
            return;
        }

        TimeSelect.change(parsedStart, parsedEnd);
        if (updateResetOnApply) {
            TimeSelect.updateResetRange();
        }
    });
    $('#timeselect-reset').click(function(event) {
        event.preventDefault();
        hideModal();
        updateResetOnApply = false;
        TimeSelect.resetTimeRange();
    });
    $('#timeselect-default').click(function(event) {
        event.preventDefault();
        hideModal();
        updateResetOnApply = false;
        TimeSelect.setDefaultTimeRange();
    });

    let haveEditedStart = false;
    let haveEditedEnd = false;

    function startTimeEdited() {
        haveEditedStart = true;
        updateResetOnApply = false;

        const parsedEnd = TimeParse.parseTime(endTimeEntry.value, TimeSelect.start_ms, 1);
        const parsedStart = TimeParse.parseTime(startTimeEntry.value, parsedEnd, -1);

        if (!parsedStart) {
            startTimeEntry.classList.add('invalid');
            startTimeDisplay.classList.add('invalid');
            displayTable.classList.remove('invalid');

            startTimeDisplay.textContent = "ERROR";
            return;
        }

        startTimeEntry.classList.remove('invalid');
        startTimeDisplay.classList.remove('invalid');
        startTimeDisplay.textContent = TimeParse.toDisplayTime(parsedStart);

        if (!haveEditedEnd) {
            const offset = TimeParse.getImpliedOffset(startTimeEntry.value, parsedStart);
            const setTime = TimeParse.parseTime(offset, parsedStart, 1);
            if (setTime) {
                endTimeEntry.classList.remove('invalid');
                endTimeDisplay.classList.remove('invalid');
                displayTable.classList.remove('invalid');
                endTimeEntry.value = offset;
                endTimeDisplay.textContent = TimeParse.toDisplayTime(setTime);
                return
            }
        }

        if (!!parsedEnd && parsedStart >= parsedEnd) {
            displayTable.classList.add('invalid');
            return
        }
        displayTable.classList.remove('invalid');
    }
    $('#input-start-time').change(startTimeEdited);
    $('#input-start-time').on('input', startTimeEdited);
    startTimeEntry.value = startTimeDisplay.textContent = TimeParse.toDisplayTime(TimeSelect.start_ms);

    function endTimeEdited() {
        haveEditedEnd = true;
        updateResetOnApply = false;

        const parsedStart = TimeParse.parseTime(startTimeEntry.value, TimeSelect.end_ms, -1);
        const parsedEnd = TimeParse.parseTime(endTimeEntry.value, parsedStart, 1);

        if (!parsedEnd) {
            endTimeEntry.classList.add('invalid');
            endTimeDisplay.classList.add('invalid');
            displayTable.classList.remove('invalid');

            endTimeDisplay.textContent = "ERROR";
            return;
        }

        endTimeEntry.classList.remove('invalid');
        endTimeDisplay.classList.remove('invalid');
        endTimeDisplay.textContent = TimeParse.toDisplayTime(parsedEnd);

        if (!haveEditedStart) {
            const offset = TimeParse.getImpliedOffset(endTimeEntry.value, parsedEnd);
            const setTime = TimeParse.parseTime(offset, parsedEnd, -1);
            if (setTime) {
                startTimeEntry.classList.remove('invalid');
                startTimeDisplay.classList.remove('invalid');
                displayTable.classList.remove('invalid');
                startTimeEntry.value = offset;
                startTimeDisplay.textContent = TimeParse.toDisplayTime(setTime);
                return;
            }
        }

        if (!!parsedStart && parsedStart >= parsedEnd) {
            displayTable.classList.add('invalid');
            return
        }
        displayTable.classList.remove('invalid');
    }
    $('#input-end-time').change(endTimeEdited);
    $('#input-end-time').on('input', endTimeEdited);
    endTimeEntry.value = endTimeDisplay.textContent = TimeParse.toDisplayTime(TimeSelect.end_ms);

    const unzoomButton = document.getElementById('timeselect-unzoom');
    function updateZoom() {
        if (!TimeSelect.isZoomed()) {
            unzoomButton.style.display = 'none';
            return;
        }

        startTimeEntry.value = startTimeDisplay.textContent = TimeParse.toDisplayTime(TimeSelect.zoom_start_ms);
        startTimeEntry.classList.remove('invalid');
        startTimeDisplay.classList.remove('invalid');
        endTimeEntry.value = endTimeDisplay.textContent = TimeParse.toDisplayTime(TimeSelect.zoom_end_ms);
        endTimeEntry.classList.remove('invalid');
        endTimeDisplay.classList.remove('invalid');
        displayTable.classList.remove('invalid')

        if (TimeSelect.zoom_start_ms === TimeSelect.start_ms && TimeSelect.zoom_end_ms === TimeSelect.end_ms) {
            unzoomButton.style.display = 'none';
        } else {
            unzoomButton.style.display = '';
        }
    }
    TimeSelect.onZoom('TimeSelectModal', updateZoom);
    updateZoom();

    $(unzoomButton).click(function(event) {
        event.preventDefault();

        startTimeEntry.value = startTimeDisplay.textContent = TimeParse.toDisplayTime(TimeSelect.start_ms);
        startTimeEntry.classList.remove('invalid');
        startTimeDisplay.classList.remove('invalid');
        endTimeEntry.value = endTimeDisplay.textContent = TimeParse.toDisplayTime(TimeSelect.end_ms);
        endTimeEntry.classList.remove('invalid');
        endTimeDisplay.classList.remove('invalid');
        displayTable.classList.remove('invalid')

        unzoomButton.style.display = 'none';
        updateResetOnApply = false;
    });

    const unpassedButton = document.getElementById('timeselect-unpassed');
    if (TimeSelect.fetchLatestPassed) {
        $(unpassedButton).click(function(event) {
          event.preventDefault();
          unpassedButton.disabled = true;

          TimeSelect.fetchLatestPassed().done(function(response) {
              const startUnpassed = response.latest_epoch_ms;
              if (!startUnpassed) {
                  return;
              }

              startTimeEntry.classList.remove('invalid');
              startTimeDisplay.classList.remove('invalid');
              endTimeEntry.classList.remove('invalid');
              endTimeDisplay.classList.remove('invalid');
              displayTable.classList.remove('invalid')

              if (TimeParse.isOffset(endTimeEntry.value)) {
                  const checkTime = TimeParse.parseTime(endTimeEntry.value, startUnpassed, 1);
                  if (checkTime) {
                      startTimeEntry.value = startTimeDisplay.textContent = TimeParse.toDisplayTime(checkTime);
                      return;
                  }
              }
              if (TimeParse.isOffset(startTimeEntry.value)) {
                  const checkTime = TimeParse.parseTime(startTimeEntry.value, startUnpassed, -1);
                  if (checkTime) {
                      endTimeEntry.value = endTimeDisplay.textContent = TimeParse.toDisplayTime(checkTime);
                      return;
                  }
              }

              startTimeEntry.value = startTimeDisplay.textContent = TimeParse.toDisplayTime(startUnpassed);
              endTimeEntry.value = "1w";
              endTimeDisplay.textContent = TimeParse.toDisplayTime(startUnpassed + 7 * 86400 * 1000);

              updateResetOnApply = true;
          }).always(function() {
              unpassedButton.style.display = 'none';
          });
      });
    } else {
        unpassedButton.style.display = 'none';
    }
})();
</script>
